translateapp/accounts/urls.py
from django.urls import path
from . import views

app_name = "accounts"

urlpatterns = [
        path('dashboard', views.dashboard, name="dashboard"),
        path('profile/<int:user_id>', views.profile, name="profile"),
        path('register', views.register, name="register"),
]

translateapp/app/urls.py
from django.urls import path
from . import views

app_name = "app"
urlpatterns = [
        path('jobs', views.jobs_index, name="jobs"),
        path('jobs/new', views.new_job, name="new_job"),
        path('jobs/<int:job_id>', views.job_detail, name="job_detail"),
        path('jobs/<int:job_id>/bid', views.bid, name="bid"),
        path('bids/<int:bid_id>/accept', views.accept_bid, name="accept_bid"),
        path('bids/<int:bid_id>/deliver', views.deliver_translation, name="deliver_translation"),
        path('bids/<int:bid_id>', views.bid_detail, name="bid_detail"),
        path('bids/<int:bid_id>/rating', views.rate_bid, name="rate_bid"),
        path('bids/<int:bid_id>/dispute', views.raise_dispute, name="dispute"),
]

translateapp/translateapp/urls.py
from django.contrib import admin
from django.urls import path, include

from app import views

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', views.home, name='home_path'),
    path('app/', include('app.urls')),
    path('accounts/', include('accounts.urls')),
    path('accounts/', include('django.contrib.auth.urls'))
]

translateapp/app/models.py
from django.db import models

from django.contrib.auth.models import User

class Account(models.Model):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    name = models.CharField(max_length=100)
    balance = models.DecimalField(max_digits=8, decimal_places=2, default=0)
    translator = models.BooleanField()
    def __str__(self):
        return f"{self.id} - {self.name}"

    def rating(self):
        ratings = Rating.objects.filter(rated=self.user)
        if ratings.count() == 0:
            return "No ratings yet"
        else:
            score = [ rating.rating for rating in ratings ]
            return sum(score) / len(score)

    def raise_if_invalid_balance(self):
        if self.balance < 0:
            raise ValueError("Balance cannot be negative")

class Job(models.Model):
    class Status(models.TextChoices):
        AVAILABLE = 'available', "Available"
        ASSIGNED = 'assigned', "Assigned"
        IN_PROGRESS = 'in_progress', "In Progress"
        COMPLETED = 'completed', "Completed"

    class Field(models.TextChoices):
        ART = 'art', "Art"
        BUS = 'business', "Business"
        COMP = 'computers', "Computers"
        EDU = 'education', "Education"
        ENG = 'engineering', "Engineering"
        FIN = 'finance', "Finance"
        LAW = 'law', "Law"
        LIT = 'literature', "Literature"
        MED = 'medicine', "Medicine"
        SCI = 'science', "Science"
        SOC = 'social_sciences', "Social Sciences"
        TECH = 'technology', "Technology"

    class Language(models.TextChoices):
        ENG = 'en', "English"
        SPA = 'spa', "Spanish"
        FRE = 'fr', "French"
        GER = 'de', "German"
        ITA = 'it', "Italian"
        JPN = 'ja', "Japanese"
        CRO = 'hr', "Croatian"

    user = models.ForeignKey(User, on_delete=models.CASCADE)
    title = models.CharField(max_length=256)
    description = models.CharField(max_length=512)
    source_lang = models.CharField(
            max_length=3, 
            choices=Language.choices,
            default=Language.ENG,
    )
    target_lang = models.CharField(
            max_length=3,
            choices=Language.choices,
            default=Language.CRO,
    )
    field = models.CharField(
            max_length=100,
            choices=Field.choices,
            default=Field.ENG,
    )
    budget = models.DecimalField(max_digits=8, decimal_places=2)
    text = models.TextField()
    status = models.CharField(
            max_length=100, 
            choices=Status.choices,
            default=Status.AVAILABLE,
    )
    translation = models.TextField(blank=True, null=True)
    def __str__(self):
        return f"{self.user.account.name} - {self.title}"

    def accepted_bid(self):
        return self.bid_set.filter(accepted=True).first()

    def accepted_bidder(self):
        return self.accepted_bid().bidder.account

    def owner(self):
        return self.user.account

    # Helper method to check if the job is available, since checking the status
    # directly from the template is not very readable.
    def is_available(self):
        return self.status == self.Status.AVAILABLE

    def is_completed(self):
        return self.status == self.Status.COMPLETED

    @classmethod
    def accepted_jobs_for(cls, user):
        # Svi bidovi gdje je user napravio job na koji je biddano
        accepted_bids = Bid.objects.filter(job__in=user.job_set.all(), accepted=True)
        # Svi jobovi gdje je user napravio job i bidano je na job 
        accepted_jobs = [ bid.job for bid in accepted_bids if bid.job.status != "completed" ]
        return accepted_jobs

class Bid(models.Model):
    bidder = models.ForeignKey(User, on_delete=models.CASCADE)
    job = models.ForeignKey(Job, on_delete=models.CASCADE)
    price = models.DecimalField(max_digits=8, decimal_places=2)
    accepted = models.BooleanField(default=False)
    completed = models.BooleanField(default=False)
    def __str__(self):
        return f"{self.bidder.account.name} - {self.job.title} - {self.price}"
    def job_owner(self):
        return self.job.user

class Dispute(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    job = models.ForeignKey(Job, on_delete=models.CASCADE)
    bid = models.OneToOneField(Bid, on_delete=models.CASCADE)
    reason = models.TextField(blank=False, null=False)

class Message(models.Model):
    sender = models.ForeignKey(User, on_delete=models.CASCADE, related_name='sender')
    receiver = models.ForeignKey(User, on_delete=models.CASCADE, related_name='receiver')
    text = models.TextField()
    sent_at = models.DateTimeField(auto_now_add=True)
    def __str__(self):
        return f"{self.sender.account.name} - {self.receiver.account.name} - {self.text[:20]}"

class Rating(models.Model):
    rater = models.ForeignKey(User, on_delete=models.CASCADE, related_name='rater')
    rated = models.ForeignKey(User, on_delete=models.CASCADE, related_name='rated')
    job = models.ForeignKey(Job, on_delete=models.CASCADE)
    bid = models.OneToOneField(Bid, on_delete=models.CASCADE)
    rating = models.IntegerField()

translateapp/app/templates/app/base.html
{% load static %}
<html>
  <head>
    <title>Translation app</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-GLhlTQ8iRABdZLl6O3oVMWSktQOp6b7In1Zl3/Jr59b6EGGoI1aFkw7cmDA6j6gD" crossorigin="anonymous">
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha1/dist/js/bootstrap.bundle.min.js" integrity="sha384-w76AqPfDkMBDXo30jS1Sgez6pr3x5MlQ1ZAGC+nuZB+EYdgRZgiwxhTBTkF7CXvN" crossorigin="anonymous"></script>
    <link rel="stylesheet" href="{% static 'app/css/app.css' %}">
  </head>

  <body>
    <nav class="navbar navbar-expand-lg">
      <div class="container-fluid  p-2 ms-4 me-4">
          <a class="navbar-brand" href="/"><img class="logo" src="../../static/app/images/logo.png"></a> <!--stavit mu logo-->
          <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarText" aria-controls="navbarText" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
          </button>
          <div class="collapse navbar-collapse" id="navbarText">
            
            <ul class="navbar-nav me-auto mb-2 mb-lg-0">

              <li class="nav-item active">
                <a class="nav-link" href="/">Home</a>
              </li>

              {% if user.is_authenticated %}
                <li class="nav-item">
                    <a class="nav-link" aria-current="page" href="{% url 'app:new_job'  %}">Submit new job</a>
                </li>
                {% if user.account.translator %}
                  <li class="nav-item">
                  <a class="nav-link" href="{% url 'app:jobs' %}">See available jobs</a>
                  </li>
                {% endif %}
              {% endif %}
            </ul>
            
            <ul class="navbar-nav ms-auto mb-2 mb-lg-0">

              {% if user.is_authenticated %}
                <li class="nav-item">
                  <a class="nav-link" href="{% url 'accounts:profile' user.id %}">My profile</a>
                </li>
                <li class="nav-item">
                  <a class="nav-link" href="{% url 'accounts:dashboard' %}">{{ user.account.name }}</a>
                </li>
                <li class="nav-item">
                  <a class="nav-link" href="{% url 'logout' %}">Logout</a>
                </li>
              {% else %}
                <li class="nav-item">
                  <a class="nav-link" href="{% url 'accounts:register' %}">Register</a>
                </li>
                <li class="nav-item">
                  <a class="nav-link" href="{% url 'login' %}">Login</a>
                </li>
              {% endif %}

            </ul>
          </div>
      </div>
    </nav>


    <!--NJEGOV KOD-->
    <div class="content container">
      <div class="row">
        {% if error %}
          <div class="col-md-12">
            <div class="alert alert-danger" role="alert">
              {{ error }}
            </div>
          </div>
        {% endif %}
        {% if message %}
          <div class="alert alert-success" role="alert">
            {{ message }}
          </div>
        {% endif %}
        <div class="col-md-12">
          {% block content %}
          {% endblock %}
        </div>
      </div>
    </div>
  </body>
</html>

translateapp/app/templates/app/bid_detail.html
{% extends 'app/base.html' %}

{% load widget_tweaks %}

{% block content %}
<div class="container">
  <div class="row">
    <div class="col-md-6">
      <h1 class="mb-5 mt-5">Translation completed!</h1>
      <p> 
        Bid from <a href="{% url 'accounts:profile' bid.bidder.id %}">{{ bid.bidder.account.name }}</a>
        for a job from <a href="{% url 'accounts:profile' job.user.id %}">{{ job.user.account.name }}</a>
      </p> 
      <p>
        <strong>{{ job.title }}</strong></br>
        {{ job.description }}
      </p>
      <p>Job budget: {{ job.budget }}; Bid amount: {{ bid.price }} </p>
    </div>
    <div class="col-md-6">
      <h1>Rating details</h1>
      {% if bid.rating  %}
        <!--if job is completed and rating exists -->
        {% if user == bid.bidder %}
          <h2>You were rated: {{ bid.rating.rating }}</h2>
        {% elif user == bid.job.user %}
          <h2>You rated this job: {{ bid.rating.rating }}</h2>
        {% endif %}
      {% elif bid.dispute  %}
        <!--if job is completed and rating exists -->
        {% if user == bid.bidder %}
          <h2>Your job got disputed!</h2>
          <p>Waiting for an admin to resolve...</p>
          <blockquote class="blockquote">
            {{ bid.dispute.reason }}
          </blockquote>
        {% elif user == bid.job.user %}
          <h2>You disputed this job!</h2>
          <blockquote class="blockquote">
            {{ bid.dispute.reason }}
          </blockquote>
        {% endif %}
      {% else %}
        <!--we are still waiting for the job owner to rate the translation -->
        {% if user == bid.bidder %}
          <h2>Waiting for the rating from the Job owner</h2>
        {% elif user == bid.job.user %}
          <h2>Rate the translation!</h2>

          <form action="{% url 'app:rate_bid' bid.id %}" method="post">
            {% csrf_token %}
            <input type="submit" value="1" name="rating" class="btn btn-primary">
            <input type="submit" value="2" name="rating" class="btn btn-primary">
            <input type="submit" value="3" name="rating" class="btn btn-primary">
            <input type="submit" value="4" name="rating" class="btn btn-primary">
            <input type="submit" value="5" name="rating" class="btn btn-primary">
          </form>
          <p>Or raise a dispute if you're not satisfied</p>

          <form action="{% url 'app:dispute' bid.id %}" method="post">
            {% csrf_token %}

            {% for field in form.visible_fields %}
              <div class="form-group">
                <label for="{{ field.id_for_label }}">{{ field.label }}</label>
                {{ field|add_class:'form-control' }}
                {% for error in field.errors %}
                  <span class="help-block">{{ error }}</span>
                {% endfor %}
              </div>
            {% endfor %}

            <div class="form-group">
              <button type="submit" class="btn btn-danger">
                <span class="glyphicon glyphicon-ok"></span> Start a Dispute
              </button>
            </div>
          </form>
        {% endif %}
      {% endif %}
    </div>
    <div class="col-md-6">
      <p><strong>Original text:</strong></p>
      <p class="with-whitespace">
        {{ job.text }}
      </p>
    </div>
    <div class="col-md-6">
      <p><strong>Translated text: </strong></p>
      <p class="with-whitespace">
        {{ job.translation }}
      </p>
    </div>
    
  </div>
</div>



{% endblock %}

translateapp/app/templates/app/deliver_translation.html
{% extends 'app/base.html' %}

{% load widget_tweaks %}

{% block content %}
  <h1 class="mb-5 mt-5">Submit your translation</h1>
  <form method="post">
    {% csrf_token %}

    {% for hidden in form.hidden_fields %}
      {{ hidden }}
    {% endfor %}

    <div class="container">
      <div class="row">
        <div class="col-md-6">
          {% for field in form.visible_fields %}
            <div class="form-group">
              <label for="{{ field.id_for_label }}">{{ field.label }}</label>
              {{ field|add_class:'form-control' }}
              {% for error in field.errors %}
                <span class="help-block">{{ error }}</span>
              {% endfor %}
            </div>
          {% endfor %}

          <div class="form-group">
            <button type="submit" class="btn btn-success">
              <span class="glyphicon glyphicon-ok"></span> Save
            </button>
            <a href="{% url 'home_path' %}" class="btn btn-default">Cancel</a>
          </div>
        </div>
      </div>
    </div>
    

  </form>
{% endblock %}

translateapp/app/templates/app/home.html
{% extends 'app/base.html' %}
{% block content %}

<div class="content container">
    <div class="row">
      <div class="col-md-12">
          <div class="p-3 mb-4 rounded-3  jumbotron-container">
              <div class="container-fluid py-4">
                  <h1 class="display-5 fw-bold">Translate-o-Rama</h1>
                  <p class="col-md-8 fs-4">Web application that enables users to hire translators to translate their texts quickly and conveniently.</p>
              </div>
          </div>
      </div>
    </div>
</div>

<p class="ms-5">Translate your texts in a jiffy</p>

{% endblock content %}

translateapp/app/templates/app/jobs_detail.html
{% extends 'app/base.html' %}


{% block content %}
<h1 class="mb-5 mt-5">{{ job.title }}</h1>
<h2>{{ job.description }}</h2>
<div class="container">
  <div class="row">
    <div class="col-md-8">
      <p><strong>Job details:</strong></p>
      <p>
        <ul>
          <!--source_lang, target_lang, field, budget, owner, text, -->
          <li>From {{ job.get_source_lang_display }} to {{ job.get_target_lang_display }}</li>
          <li>Field: {{ job.get_field_display }}</li>
          <li>Budget: {{ job.budget }}</li>
          <li>Owner: {{ job.owner }}</li>
        </ul>
      </p>
    </div>
    <div class="col-md-4">
      <h2>Enter your bid:</h2>
      <form action="{% url 'app:bid' job.id %}" method="post" >
        {% csrf_token %}
        <div class="form-group">
          <label for="price">Bid</label>
          <input type="number" class="form-control" id="price" name="price" placeholder="Enter bid">
          {% for error in form.price.errors %}
            <span class="help-block">{{ error }}</span>
          {% endfor %}
        </div>
        <button type="submit" class="btn btn-primary">Submit</button>
        
      </form>
    </div>
  </div>
</div>
<p class="with-whitespace">
  <strong>Text:</strong></br>
  {{ job.text }}
</p>




{% endblock content %}

translateapp/app/templates/app/jobs_index.html
{% extends 'app/base.html' %}


{% block content %}
<h1 class="mb-5 mt-5">Available jobs</h1>

<table class="jobs">
{% for job in jobs %}
    <tr>
      <td>
        <strong>
          <a href="{% url 'app:job_detail' job.id %}">{{ job.title }}</a>
        </strong>
      </td>
      <td>
        <a href="{% url 'accounts:profile' job.user.id %}">
          {{ job.owner.name }}
        </a>
      </td>
      <!--https://stackoverflow.com/a/6127466/347891-->
      <td>{{ job.get_source_lang_display }} to {{ job.get_target_lang_display }} </td>
      <td>Budget: {{ job.budget }}</td>
    </tr>
    <tr>
      <td colspan="3">
        {{ job.description }}
      </td>
      <td>
        {{ job.get_field_display }}
      </td>
    </tr>
    <tr>
      <td colspan="4" class="bid-controls-row">
        <a href="{% url 'app:job_detail' job.id %}" class="btn btn-success mt-3 ">Submit a quote</a>
        <a href="{% url 'app:job_detail' job.id %}" class="btn btn-primary ms-2 mt-3 ">Message Job Owner</a>
      </td>
    </tr>
{% empty %}
  <tr>
    <td colspan="4"> No available jobs at this moment</td>
  </tr>
{% endfor %}
</table>

{% endblock content %}

translateapp/app/templates/app/jobs_new.html
{% extends 'app/base.html' %}

{% load widget_tweaks %}

{% block content %}
  <h1 class="mb-5 mt-5">Submit new job</h1>
  <form method="post">
    {% csrf_token %}

    {% for hidden in form.hidden_fields %}
      {{ hidden }}
    {% endfor %}

    <div class="container">
      <div class="row">
        <div class="col-md-6">
          {% for field in form.visible_fields %}
            {% if field.label != "Text" %}
              <div class="form-group mt-3">
                <label for="{{ field.id_for_label }}">{{ field.label }}</label>
                {{ field|add_class:'form-control' }}
                {% for error in field.errors %}
                  <span class="help-block">{{ error }}</span>
                {% endfor %}
              </div>
            {% endif %}
          {% endfor %}

          <div class="form-group mt-4 mb-5">
            <button type="submit" class="btn custom-btn px-4 ">
              <span class="glyphicon glyphicon-ok"></span> Save
            </button>
            <a href="{% url 'home_path' %}" class="btn btn-default">Cancel</a>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group mt-3">
            <label for="{{ form.text.id_for_label }}">{{ form.text.label }}</label>
            {{ form.text|add_class:'form-control' }}
            {% for error in form.text.errors %}
              <span class="help-block">{{ error }}</span>
            {% endfor %}
          </div>
        </div>
      </div>
    </div>
    

  </form>
{% endblock %}